<template>
    <h2>Правила</h2>
    <RulesToolbar :rules="rules" :tests="tests" />
    <el-collapse>
        <Rule
            v-for="(rule, index) in RulesStore.rules"
            :key="index"
            :rule="rule"
            :errors="validationErrors[index] || {}"
            @on-update="(path, value) => onUpdate(index, path, value)"
            @on-move-up="moveUpRule(index)"
            @on-move-down="moveDownRule(index)"
            @on-delete="deleteRule(index)"
            @on-clone="cloneRule(index)"
        />
    </el-collapse>
    <el-button class="addbutton" type="primary" plain @click="() => RulesStore.addRule(ruleDefaults)">
        Добавить правило
    </el-button>
</template>

<script>
import { useParseRulesStore } from "@/js/stores/RulesStore";
import { computed } from "vue";
import RulesToolbar from "@/views/pages/ParseRules/RulesToolbar.vue";
import Rule from "@/views/pages/ParseRules/Rule.vue";

export default {
    components: { RulesToolbar, Rule },
    props: {
        rules: Object,
        tests: Object,
        // Используют ся при создании новых правил
        ruleDefaults: {
            type: Object,
            default() {
                return {
                    title: "Новое правило",
                    execute_if: [],
                    type: "regex",
                    regex: "",
                    remove_found: 0,
                    note: "",
                };
            },
        },
    },
    emits: ["onUpdate", "onCreate", "onDelete"],
    data() {
        return {};
    },
    setup() {
        const RulesStore = useParseRulesStore();
        return {
            RulesStore,
            validationErrors: computed(() => RulesStore.validationErrors),
        };
    },
    methods: {
        moveUpRule(index) {
            this.RulesStore.swapRules(index, index - 1);
        },
        moveDownRule(index) {
            this.RulesStore.swapRules(index, index + 1);
        },
        deleteRule(index) {
            this.RulesStore.deleteRule(index);
        },
        cloneRule(index) {
            this.RulesStore.cloneRule(index);
        },
        onUpdate(index, path, value) {
            this.RulesStore.updateRule(index, path, value);
        },
    },
};
</script>

<style scoped>
.addbutton {
    margin-top: 20px;
}
</style>
